Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/EditCloudConnectionWizard.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/EditCloudConnectionWizard.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/EditCloudConnectionWizard.java	(working copy)
@@ -12,9 +12,14 @@
 
 import java.text.MessageFormat;
 
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.core.runtime.jobs.Job;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
-import org.jboss.tools.deltacloud.core.Driver;
-import org.jboss.tools.deltacloud.ui.ErrorUtils;
+import org.jboss.tools.deltacloud.core.DeltaCloudDriver;
+import org.jboss.tools.deltacloud.core.job.AbstractCloudJob;
+import org.jboss.tools.internal.deltacloud.ui.utils.WizardUtils;
 
 /**
  * @author Jeff Johnston
@@ -30,19 +35,30 @@
 
 	@Override
 	public boolean performFinish() {
-		String name = mainPage.getModel().getName();
-		String url = mainPage.getModel().getUrl();
-		String username = mainPage.getModel().getUsername();
-		String password = mainPage.getModel().getPassword();
-		Driver driver = mainPage.getModel().getDriver();
+		String name = mainPage.getConnectionName();
+		String url = mainPage.getUrl();
+		String username = mainPage.getUsername();
+		String password = mainPage.getPassword();
+		DeltaCloudDriver driver = mainPage.getDriver();
+		return editCloud(initialCloud, name, url, username, password, driver);
+	}
+
+	private boolean editCloud(final DeltaCloud cloud, final String name, final String url, final String username,
+			final String password, final DeltaCloudDriver driver) {
 		try {
-			initialCloud.update(name, url, username, password, driver);
+			Job job = new AbstractCloudJob(MessageFormat.format("Edit cloud \"{0}\"", cloud.getName()), cloud) {
+
+				@Override
+				protected IStatus doRun(IProgressMonitor monitor) throws Exception {
+					initialCloud.update(name, url, username, password, driver);
+					return Status.OK_STATUS;
+				}
+			};
+			WizardUtils.runInWizard(job, getContainer());
+			return job.getResult() != null && job.getResult().getCode() != IStatus.ERROR;
 		} catch (Exception e) {
-			// TODO internationalize strings
-			ErrorUtils.handleError("Error",
-					MessageFormat.format("Could not edit cloud \"{0}\"", initialCloud.getName()),
-					e, getShell());
+			return false;
 		}
-		return true;
 	}
+
 }
Index: src/org/jboss/tools/deltacloud/ui/commands/AbstractInstanceHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/AbstractInstanceHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/AbstractInstanceHandler.java	(working copy)
@@ -15,10 +15,11 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
+import org.jboss.tools.deltacloud.core.DeltaCloudResourceAction;
 import org.jboss.tools.deltacloud.core.client.utils.StringUtils;
 import org.jboss.tools.deltacloud.core.client.utils.StringUtils.IElementFormatter;
 import org.jboss.tools.deltacloud.core.job.InstanceActionJob;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * A base handler that instance related handler may extend
@@ -27,7 +28,7 @@
  */
 public abstract class AbstractInstanceHandler extends AbstractHandler implements IHandler {
 
-	protected void executeInstanceAction(DeltaCloudInstance instance, DeltaCloudInstance.Action action,
+	protected void executeInstanceAction(DeltaCloudInstance instance, DeltaCloudResourceAction action,
 			DeltaCloudInstance.State expectedState, String title, String message) {
 		if (instance != null) {
 			new InstanceActionJob(message, instance, action, expectedState)
@@ -36,7 +37,7 @@
 	}
 
 	protected boolean isSingleInstanceSelected(ISelection selection) {
-		return UIUtils.isSingleSelection(selection, DeltaCloudInstance.class);
+		return WorkbenchUtils.isSingleSelection(selection, DeltaCloudInstance.class);
 	}
 
 	@SuppressWarnings("unchecked")
@@ -48,7 +49,7 @@
 					public String format(Object element) {
 						if (element instanceof DeltaCloudInstance) {
 							return new StringBuilder()
-									.append(((DeltaCloudInstance) element).getName())
+									.append(((DeltaCloudInstance) element).getAlias())
 									.append(",")
 									.toString();
 						} else {
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/ManageKeysPageModel.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/ManageKeysPageModel.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/ManageKeysPageModel.java	(working copy)
@@ -55,7 +55,7 @@
 			return null;
 		}
 		DeltaCloudKey keyToDelete = selectedKey;
-		cloud.deleteKey(keyToDelete.getId());
+		cloud.delete(keyToDelete);
 		int index = keys.indexOf(keyToDelete);
 		keys.remove(keyToDelete);
 		fireIndexedPropertyChange(PROP_KEYS, index, keyToDelete, null);
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/InstanceFilterWizard.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/InstanceFilterWizard.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/InstanceFilterWizard.java	(working copy)
@@ -10,7 +10,6 @@
  ******************************************************************************/
 package org.jboss.tools.internal.deltacloud.ui.wizards;
 
-import org.eclipse.jface.wizard.Wizard;
 import org.eclipse.swt.widgets.Display;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.ui.ErrorUtils;
@@ -18,51 +17,46 @@
 /**
  * @author Jeff Johnston
  */
-public class InstanceFilterWizard extends Wizard {
+public class InstanceFilterWizard extends AbstractDeltaCloudWizard {
 
-	private DeltaCloud cloud;
 	private InstanceFilterPage mainPage;
-	
+
 	public InstanceFilterWizard(DeltaCloud cloud) {
-		this.cloud = cloud;
+		super(cloud);
 	}
-	
+
 	@Override
 	public void addPages() {
-		mainPage = new InstanceFilterPage(cloud);
+		mainPage = new InstanceFilterPage(getDeltaCloud());
 		addPage(mainPage);
 	}
-	
+
 	@Override
 	public boolean canFinish() {
 		return mainPage.isPageComplete();
 	}
-	
+
 	@Override
 	public boolean performFinish() {
 		String nameRule = mainPage.getNameRule();
 		String idRule = mainPage.getIdRule();
+		String aliasRule = mainPage.getAliasRule();
 		String imageIdRule = mainPage.getImageIdRule();
 		String ownerIdRule = mainPage.getOwnerIdRule();
 		String keyNameRule = mainPage.getKeyNameRule();
 		String realmRule = mainPage.getRealmRule();
 		String profileRule = mainPage.getProfileRule();
-		
+
 		try {
-			cloud.updateInstanceFilter(nameRule + ";" + //$NON-NLS-1$
-					idRule + ";" + //$NON-NLS-1$
-					imageIdRule + ";" + //$NON-NLS-1$
-					ownerIdRule + ";" + //$NON-NLS-1$
-					keyNameRule + ";" + //$NON-NLS-1$
-					realmRule + ";" + //$NON-NLS-1$
-					profileRule);
+			getDeltaCloud().updateInstanceFilter(
+					nameRule, idRule, aliasRule, imageIdRule, ownerIdRule, keyNameRule, realmRule, profileRule);
 		} catch (Exception e) {
 			// TODO: internationalize strings
 			ErrorUtils.handleError(
 					"Error",
 					"Could not update filters", e, Display.getDefault().getActiveShell());
 		}
-		
+
 		return true;
 	}
 
Index: src/org/jboss/tools/deltacloud/ui/commands/StopInstanceHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/StopInstanceHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/StopInstanceHandler.java	(working copy)
@@ -23,9 +23,12 @@
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.jboss.tools.common.log.StatusFactory;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
+import org.jboss.tools.deltacloud.core.DeltaCloudResourceAction;
 import org.jboss.tools.deltacloud.ui.Activator;
+import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
 import org.jboss.tools.deltacloud.ui.views.CVMessages;
 import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * @author Andre Dietisheim
@@ -43,7 +46,8 @@
 		try {
 			if (selection instanceof IStructuredSelection) {
 				if (isSingleInstanceSelected(selection)) {
-					DeltaCloudInstance instance = UIUtils.getFirstAdaptedElement(selection, DeltaCloudInstance.class);
+					DeltaCloudInstance instance = WorkbenchUtils.getFirstAdaptedElement(selection,
+							DeltaCloudInstance.class);
 					stopInstance(instance);
 				} else {
 					stopWithDialog((IStructuredSelection) selection);
@@ -59,11 +63,12 @@
 
 	@SuppressWarnings("unchecked")
 	private void stopWithDialog(IStructuredSelection selection) {
-		List<DeltaCloudInstance> deltaCloudInstances = UIUtils.adapt((List<DeltaCloudInstance>) selection.toList(),
+		List<DeltaCloudInstance> deltaCloudInstances = WorkbenchUtils.adapt(
+				(List<DeltaCloudInstance>) selection.toList(),
 				DeltaCloudInstance.class);
 		List<DeltaCloudInstance> stoppableInstances = getStoppableInstances(deltaCloudInstances);
 		DeltaCloudInstanceDialog dialog = new DeltaCloudInstanceDialog(
-					UIUtils.getActiveShell()
+				WorkbenchUtils.getActiveShell()
 					, stoppableInstances
 					, CVMessages.getString(STOP_INSTANCES_DIALOG_TITLE)
 					, CVMessages.getString(STOP_INSTANCES_DIALOG_MSG));
@@ -84,19 +89,41 @@
 	}
 
 	private void stopInstances(Object[] deltaCloudInstances) {
-		for (int i = 0; i < deltaCloudInstances.length; i++) {
-			stopInstance((DeltaCloudInstance) deltaCloudInstances[i]);
+		if (askUserToConfirm()) {
+			for (int i = 0; i < deltaCloudInstances.length; i++) {
+				stopInstance((DeltaCloudInstance) deltaCloudInstances[i]);
+			}
 		}
 	}
 
 	private void stopInstance(DeltaCloudInstance instance) {
 		if (instance != null) {
+			if (askUserToConfirm()) {
+				doStopInstance(instance);
+			}
+		}
+	}
+
+	private void doStopInstance(DeltaCloudInstance instance) {
+		if (instance != null) {
 			executeInstanceAction(
-					instance
-					, DeltaCloudInstance.Action.STOP
-					, DeltaCloudInstance.State.STOPPED
-					, CVMessages.getString(STOPPING_INSTANCE_TITLE)
-					, CVMessages.getFormattedString(STOPPING_INSTANCE_MSG, new String[] { instance.getName() }));
+						instance
+						, DeltaCloudResourceAction.STOP
+						, DeltaCloudInstance.State.STOPPED
+						, CVMessages.getString(STOPPING_INSTANCE_TITLE)
+						, CVMessages.getFormattedString(STOPPING_INSTANCE_MSG, new String[] { instance.getAlias() }));
 		}
 	}
+
+	private boolean askUserToConfirm() {
+		return UIUtils
+				.openConfirmationDialog(
+						"Confirm instance stop",
+						"You are about to stop a running system(s), that might be in production. Are you sure that you want to stop the given instance(s)?",
+						"Don't warn me again",
+						IDeltaCloudPreferenceConstants.DONT_CONFIRM_CREATE_INSTANCE,
+						Activator.PLUGIN_ID,
+						WorkbenchUtils.getActiveShell());
+	}
+
 }
Index: src/org/jboss/tools/deltacloud/ui/commands/EditConnectionHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/EditConnectionHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/EditConnectionHandler.java	(working copy)
@@ -21,7 +21,7 @@
 import org.eclipse.jface.wizard.WizardDialog;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 import org.jboss.tools.internal.deltacloud.ui.wizards.EditCloudConnectionWizard;
 
 /**
@@ -33,10 +33,10 @@
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		ISelection selection = HandlerUtil.getCurrentSelection(event);
 		if (selection instanceof IStructuredSelection) {
-			DeltaCloud cloud = UIUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
+			DeltaCloud cloud = WorkbenchUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
 			if (cloud != null) {
 				IWizard wizard = new EditCloudConnectionWizard(cloud);
-				WizardDialog dialog = new WizardDialog(UIUtils.getActiveWorkbenchWindow().getShell(), wizard);
+				WizardDialog dialog = new WizardDialog(WorkbenchUtils.getActiveWorkbenchWindow().getShell(), wizard);
 				dialog.create();
 				dialog.open();
 			}
Index: src/org/jboss/tools/deltacloud/ui/views/cloud/DeltaCloudView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloud/DeltaCloudView.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/cloud/DeltaCloudView.java	(working copy)
@@ -25,7 +25,7 @@
 import org.jboss.tools.deltacloud.ui.SWTImagesFactory;
 import org.jboss.tools.deltacloud.ui.views.CVMessages;
 import org.jboss.tools.deltacloud.ui.views.cloud.property.CVPropertySheetPage;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 public class DeltaCloudView extends ViewPart implements ITabbedPropertySheetPageContributor {
 
@@ -63,8 +63,8 @@
 	}
 
 	private void hookContextMenu(Control control) {
-		IMenuManager contextMenu = UIUtils.createContextMenu(control);
-		UIUtils.registerContributionManager(UIUtils.getContextMenuId(ID), contextMenu, control);
+		IMenuManager contextMenu = WorkbenchUtils.createContextMenu(control);
+		WorkbenchUtils.registerContributionManager(WorkbenchUtils.getContextMenuId(ID), contextMenu, control);
 	}
 
 	private void contributeToActionBars() {
Index: src/org/jboss/tools/deltacloud/ui/commands/FilterImagesHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/FilterImagesHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/FilterImagesHandler.java	(working copy)
@@ -17,13 +17,12 @@
 import org.eclipse.core.runtime.Status;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.jface.wizard.IWizard;
-import org.eclipse.jface.wizard.WizardDialog;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WizardUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 import org.jboss.tools.internal.deltacloud.ui.wizards.ImageFilterWizard;
 
 /**
@@ -35,7 +34,7 @@
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		ISelection selection = HandlerUtil.getCurrentSelection(event);
 		if (selection instanceof IStructuredSelection) {
-			DeltaCloud cloud = UIUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
+			DeltaCloud cloud = WorkbenchUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
 			createImagesFilter(cloud, HandlerUtil.getActiveShell(event));
 		}
 
@@ -47,10 +46,7 @@
 				Display.getDefault().asyncExec(new Runnable() {
 					@Override
 					public void run() {
-						IWizard wizard = new ImageFilterWizard(cloud);
-						WizardDialog dialog = new WizardDialog(shell, wizard);
-						dialog.create();
-						dialog.open();
+						WizardUtils.openWizardDialog(new ImageFilterWizard(cloud), shell);
 					}
 				});
 
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/ImageFilterPage.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/ImageFilterPage.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/ImageFilterPage.java	(working copy)
@@ -10,12 +10,8 @@
  ******************************************************************************/
 package org.jboss.tools.internal.deltacloud.ui.wizards;
 
-import org.eclipse.jface.wizard.WizardPage;
+import org.eclipse.jface.fieldassist.ControlDecoration;
 import org.eclipse.swt.SWT;
-import org.eclipse.swt.events.ModifyEvent;
-import org.eclipse.swt.events.ModifyListener;
-import org.eclipse.swt.events.SelectionAdapter;
-import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.graphics.Point;
 import org.eclipse.swt.layout.FormAttachment;
 import org.eclipse.swt.layout.FormData;
@@ -25,108 +21,85 @@
 import org.eclipse.swt.widgets.Label;
 import org.eclipse.swt.widgets.Text;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
-import org.jboss.tools.deltacloud.ui.SWTImagesFactory;
+import org.jboss.tools.deltacloud.core.IImageFilter;
+import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
 
 /**
  * @author Jeff Johnston
  */
-public class ImageFilterPage extends WizardPage {
+public class ImageFilterPage extends AbstractFilterPage {
 
 	private final static String NAME = "ImageFilter.name"; //$NON-NLS-1$
 	private final static String TITLE = "ImageFilter.title"; //$NON-NLS-1$
 	private final static String DESC = "ImageFilter.desc"; //$NON-NLS-1$
 	private final static String FILTER_LABEL = "ImageFilter.label"; //$NON-NLS-1$
-	private final static String EMPTY_RULE = "ErrorFilterEmptyRule.msg"; //$NON-NLS-1$
-	private final static String INVALID_SEMICOLON = "ErrorFilterSemicolon.msg"; //$NON-NLS-1$
 	private final static String NAME_LABEL = "Name.label"; //$NON-NLS-1$
 	private final static String ID_LABEL = "Id.label"; //$NON-NLS-1$
 	private final static String ARCH_LABEL = "Arch.label"; //$NON-NLS-1$
 	private final static String DESC_LABEL = "Desc.label"; //$NON-NLS-1$
-	private final static String DEFAULT_LABEL = "DefaultButton.label"; //$NON-NLS-1$
-	
-	private DeltaCloud cloud;
+
 	private Text nameText;
-	private Text idText;
-	private Text archText;
-	private Text descText;
-	
+	private ControlDecoration nameDecoration;
 	private Button defaultName;
+	private Text idText;
+	private ControlDecoration idDecoration;
 	private Button defaultId;
+	private Text archText;
+	private ControlDecoration archDecoration;
 	private Button defaultArch;
+	private Text descText;
+	private ControlDecoration descDecoration;
 	private Button defaultDesc;
-	
+
 	public ImageFilterPage(DeltaCloud cloud) {
-		super(WizardMessages.getString(NAME));
-		this.cloud = cloud;
-		setDescription(WizardMessages.getString(DESC));
-		setTitle(WizardMessages.getString(TITLE));
-		setImageDescriptor(SWTImagesFactory.DESC_DELTA_LARGE);
+		super(WizardMessages.getString(NAME), WizardMessages.getString(TITLE), WizardMessages.getString(DESC), cloud);
 		setPageComplete(false);
 	}
-	
+
 	public String getNameRule() {
 		return nameText.getText();
 	}
-	
+
 	public String getIdRule() {
 		return idText.getText();
 	}
-	
+
 	public String getArchRule() {
 		return archText.getText();
 	}
-	
+
 	public String getDescRule() {
 		return descText.getText();
 	}
-	
-	private ModifyListener Listener = new ModifyListener() {
 
-		@Override
-		public void modifyText(ModifyEvent e) {
-			// TODO Auto-generated method stub
-			validate();
-		}
-	};
-	
-	private SelectionAdapter ButtonListener = new SelectionAdapter() {
-		@Override
-		public void widgetSelected(SelectionEvent e) {
-			Button b = (Button)e.widget;
-			if (b == defaultName)
-				nameText.setText("*"); //$NON-NLS-1$
-			else if (b == defaultId)
-				idText.setText("*"); //$NON-NLS-1$
-			else if (b == defaultArch)
-				archText.setText("*"); //$NON-NLS-1$
-			else if (b == defaultDesc)
-				descText.setText("*"); //$NON-NLS-1$
-		}
-	
-	};
-	
-	private void validate() {
-		boolean complete = true;
-		boolean error = false;
-	
-		if (nameText.getText().length() == 0 ||
-				idText.getText().length() == 0 ||
-				archText.getText().length() == 0 ||
-				descText.getText().length() == 0) {
-			
-			setErrorMessage(WizardMessages.getString(EMPTY_RULE));
-			error = true;
-		} else if (nameText.getText().contains(";") ||
-				idText.getText().contains(";") ||
-				archText.getText().contains(";") ||
-				descText.getText().contains(";")) {
-			setErrorMessage(WizardMessages.getString(INVALID_SEMICOLON));
-			error = true;
+	@Override
+	protected Text getTextWidget(Button button) {
+		Text text = null;
+		if (button == defaultName) {
+			text = nameText;
+		} else if (button == defaultId) {
+			text = idText;
+		} else if (button == defaultArch) {
+			text = archText;
+		} else if (button == defaultDesc) {
+			text = descText;
 		}
-		
-		if (!error)
-			setErrorMessage(null);
-		setPageComplete(complete && !error);
+		return text;
+	}
+
+	@Override
+	protected void validate() {
+		nameDecoration.hide();
+		idDecoration.hide();
+		archDecoration.hide();
+		descDecoration.hide();
+		String error = null;
+		error = validate(nameText, nameDecoration, error);
+		error = validate(idText, idDecoration, error);
+		error = validate(archText, archDecoration, error);
+		error = validate(descText, descDecoration, error);
+		setPageComplete(error == null);
+		setErrorMessage(error);
 	}
 
 	@Override
@@ -135,54 +108,32 @@
 		FormLayout layout = new FormLayout();
 		layout.marginHeight = 5;
 		layout.marginWidth = 5;
-		container.setLayout(layout);		
+		container.setLayout(layout);
+
+		IImageFilter filter = getDeltaCloud().getImageFilter();
 
 		Label label = new Label(container, SWT.NULL);
 		label.setText(WizardMessages.getString(FILTER_LABEL));
-		
-		Label nameLabel = new Label(container, SWT.NULL);
-		nameLabel.setText(WizardMessages.getString(NAME_LABEL));
-		
-		nameText = new Text(container, SWT.BORDER | SWT.SINGLE);
-		nameText.setText(cloud.getImageFilter().getNameRule().toString());
-		nameText.addModifyListener(Listener);
-		
-		defaultName = new Button(container, SWT.NULL);
-		defaultName.setText(WizardMessages.getString(DEFAULT_LABEL));
-		defaultName.addSelectionListener(ButtonListener);
-
-		Label idLabel = new Label(container, SWT.NULL);
-		idLabel.setText(WizardMessages.getString(ID_LABEL));
-
-		idText = new Text(container, SWT.BORDER | SWT.SINGLE);
-		idText.setText(cloud.getImageFilter().getIdRule().toString());
-		idText.addModifyListener(Listener);
 
-		defaultId = new Button(container, SWT.NULL);
-		defaultId.setText(WizardMessages.getString(DEFAULT_LABEL));
-		defaultId.addSelectionListener(ButtonListener);
+		Label nameLabel = createRuleLabel(WizardMessages.getString(NAME_LABEL), container);
+		this.nameText = createRuleText(filter.getNameRule(), container);
+		this.nameDecoration = UIUtils.createErrorDecoration("", nameText);
+		this.defaultName = createDefaultRuleButton(container);
 
-		Label archLabel = new Label(container, SWT.NULL);
-		archLabel.setText(WizardMessages.getString(ARCH_LABEL));
-		
-		archText = new Text(container, SWT.BORDER | SWT.SINGLE);
-		archText.setText(cloud.getImageFilter().getArchRule().toString());
-		archText.addModifyListener(Listener);
-		
-		defaultArch = new Button(container, SWT.NULL);
-		defaultArch.setText(WizardMessages.getString(DEFAULT_LABEL));
-		defaultArch.addSelectionListener(ButtonListener);
+		Label idLabel = createRuleLabel(WizardMessages.getString(ID_LABEL), container);
+		this.idText = createRuleText(filter.getIdRule(), container);
+		this.idDecoration = UIUtils.createErrorDecoration("", idText);
+		this.defaultId = createDefaultRuleButton(container);
 
-		Label descLabel = new Label(container, SWT.NULL);
-		descLabel.setText(WizardMessages.getString(DESC_LABEL));
+		Label archLabel = createRuleLabel(WizardMessages.getString(ARCH_LABEL), container);
+		this.archText = createRuleText(filter.getArchRule(), container);
+		this.archDecoration = UIUtils.createErrorDecoration(WizardMessages.getString(""), archText);
+		this.defaultArch = createDefaultRuleButton(container);
 
-		descText = new Text(container, SWT.BORDER | SWT.SINGLE);
-		descText.setText(cloud.getImageFilter().getDescRule().toString());
-		descText.addModifyListener(Listener);
-		
-		defaultDesc = new Button(container, SWT.NULL);
-		defaultDesc.setText(WizardMessages.getString(DEFAULT_LABEL));
-		defaultDesc.addSelectionListener(ButtonListener);
+		Label descLabel = createRuleLabel(WizardMessages.getString(DESC_LABEL), container);
+		this.descText = createRuleText(filter.getDescRule(), container);
+		this.descDecoration = UIUtils.createErrorDecoration("", descText);
+		this.defaultDesc = createDefaultRuleButton(container);
 
 		Point p1 = label.computeSize(SWT.DEFAULT, SWT.DEFAULT);
 		Point p2 = nameText.computeSize(SWT.DEFAULT, SWT.DEFAULT);
@@ -193,28 +144,28 @@
 		FormData f = new FormData();
 		f.top = new FormAttachment(0);
 		label.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(label, 11 + centering + centering2);
 		f.left = new FormAttachment(0, 0);
 		nameLabel.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(label, 11);
 		f.right = new FormAttachment(100);
 		defaultName.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(label, 11 + centering2);
 		f.left = new FormAttachment(archLabel, 5);
 		f.right = new FormAttachment(defaultName, -10);
 		nameText.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(nameLabel, 11 + centering + centering2);
 		f.left = new FormAttachment(0, 0);
 		idLabel.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(nameLabel, 11);
 		f.right = new FormAttachment(100);
@@ -230,7 +181,7 @@
 		f.top = new FormAttachment(idLabel, 11 + centering + centering2);
 		f.left = new FormAttachment(0, 0);
 		archLabel.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(idLabel, 11);
 		f.right = new FormAttachment(100);
@@ -241,12 +192,12 @@
 		f.left = new FormAttachment(archLabel, 5);
 		f.right = new FormAttachment(defaultArch, -10);
 		archText.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(archLabel, 11 + centering + centering2);
 		f.left = new FormAttachment(0, 0);
 		descLabel.setLayoutData(f);
-		
+
 		f = new FormData();
 		f.top = new FormAttachment(archLabel, 11);
 		f.right = new FormAttachment(100);
@@ -261,5 +212,4 @@
 		setControl(container);
 		setPageComplete(true);
 	}
-
 }
Index: src/org/jboss/tools/deltacloud/ui/SWTImagesFactory.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/SWTImagesFactory.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/SWTImagesFactory.java	(working copy)
@@ -34,21 +34,27 @@
 	}	
 	private static final String NAME_PREFIX= Activator.PLUGIN_ID + '.';
 	private static final int NAME_PREFIX_LENGTH= NAME_PREFIX.length();
-	public static final String IMG_CLOUD= NAME_PREFIX + "cloud.gif"; //$NON-NLS-1$
-	public static final String IMG_FOLDER= NAME_PREFIX + "folder.gif"; //$NON-NLS-1$
-	public static final String IMG_INSTANCE= NAME_PREFIX + "instance.gif"; //$NON-NLS-1$
-	public static final String IMG_IMAGE= NAME_PREFIX + "image.gif"; //$NON-NLS-1$
+	public static final String IMG_CLOUD= NAME_PREFIX + "delta.png"; //$NON-NLS-1$
+//	public static final String IMG_CLOUD= NAME_PREFIX + "cloud.gif"; //$NON-NLS-1$
 	public static final String IMG_COLLAPSE_ALL= NAME_PREFIX + "collapseall.gif"; //$NON-NLS-1$
 	public static final String IMG_DELTA= NAME_PREFIX + "delta.gif"; //$NON-NLS-1$
 	public static final String IMG_DELTA_LARGE= NAME_PREFIX + "delta-large.gif"; //$NON-NLS-1$
+	public static final String IMG_DESTROY = NAME_PREFIX + "destroy.gif"; //$NON-NLS-1$
+	public static final String IMG_DESTROY_D = NAME_PREFIX + "destroyd.gif"; //$NON-NLS-1$
+	public static final String IMG_FOLDER= NAME_PREFIX + "folder.gif"; //$NON-NLS-1$
+	public static final String IMG_IMAGE= NAME_PREFIX + "image.gif"; //$NON-NLS-1$
+	public static final String IMG_INSTANCE= NAME_PREFIX + "instance.gif"; //$NON-NLS-1$
+	public static final String IMG_NEW_DELTA= NAME_PREFIX + "newdelta.gif"; //$NON-NLS-1$
+	public static final String IMG_REBOOT = NAME_PREFIX + "reboot.gif"; //$NON-NLS-1$
+	public static final String IMG_REBOOTD = NAME_PREFIX + "rebootd.gif"; //$NON-NLS-1$
 	public static final String IMG_START= NAME_PREFIX + "run.gif"; //$NON-NLS-1$
 	public static final String IMG_STARTD = NAME_PREFIX + "rund.gif"; //$NON-NLS-1$
+	public static final String IMG_RUNNING= NAME_PREFIX + "running.gif"; //$NON-NLS-1$
 	public static final String IMG_STOP = NAME_PREFIX + "stop.gif"; //$NON-NLS-1$
 	public static final String IMG_STOPD = NAME_PREFIX + "stopd.gif"; //$NON-NLS-1$
 	public static final String IMG_STOPPED = NAME_PREFIX + "stopped.gif"; //$NON-NLS-1$
-	public static final String IMG_REBOOT = NAME_PREFIX + "reboot.gif"; //$NON-NLS-1$
-	public static final String IMG_REBOOTD = NAME_PREFIX + "rebootd.gif"; //$NON-NLS-1$
-	public static final String IMG_RUNNING= NAME_PREFIX + "running.gif"; //$NON-NLS-1$
+	public static final String SYSTEM_VIEW = NAME_PREFIX + "system_view.gif"; //$NON-NLS-1$
+	public static final String SYSTEM_VIEWD = NAME_PREFIX + "system_viewd.gif"; //$NON-NLS-1$
 	public static final ImageDescriptor DESC_CLOUD= createManaged("", IMG_CLOUD);
 	public static final ImageDescriptor DESC_FOLDER= createManaged("", IMG_FOLDER);
 	public static final ImageDescriptor DESC_INSTANCE= createManaged("", IMG_INSTANCE);
@@ -56,6 +62,9 @@
 	public static final ImageDescriptor DESC_COLLAPSE_ALL= createManaged("", IMG_COLLAPSE_ALL);
 	public static final ImageDescriptor DESC_DELTA= createManaged("", IMG_DELTA);
 	public static final ImageDescriptor DESC_DELTA_LARGE= createManaged("", IMG_DELTA_LARGE);
+	public static final ImageDescriptor DESC_NEW_DELTA= createManaged("", IMG_NEW_DELTA);
+	public static final ImageDescriptor DESC_DESTROY = createManaged("", IMG_DESTROY);
+	public static final ImageDescriptor DESC_DESTROYD= createManaged("", IMG_DESTROY_D);
 	public static final ImageDescriptor DESC_START= createManaged("", IMG_START);
 	public static final ImageDescriptor DESC_STARTD= createManaged("", IMG_STARTD);
 	public static final ImageDescriptor DESC_RUNNING= createManaged("", IMG_RUNNING);
